/*
		 Jogo da Forca
	
	Cesar Henrique Kallas 	 RA: 02099224
	opensrc@gmx.net
	
	Plp 1 - Lab
	Pontificia Universidade Catolica - Campinas
	05/2003
	
	Compile usando javac JogoForca.java	
	para executar digite: java jogo
*/	

import java.io.*;
import java.util.Random;	/* usar random */

class Palavra{
/* classe que retorna uma palavra da opcao escolhida pelo usuario */
	
/* Vetores de palavras para a forca, retorna uma palavra escolhida por um numero randomico */

/* opcao 0 */
	private String animal[] = { "gato", "cachorro", "pato", "canguru", "galinha", 
			"macaco", "cobra", "boi", "vaca", "hipopotamo" };
/* opcao 1 */
	private String objeto[] = { "mouse", "teclado", "monitor", "harddisk", "cdrom",
			"capacitor", "memoria", "modem", "motherboard", "processador" };
/* opcao 2 */
	private String carro[] = { "santana", "siena", "corvette", "lamborchini", "pontiac",
			"mustang", "cadillac", "chrysler", "civic", "mercedes"  };
/* opcao 3 */
	private String celula[] = { "lisossoma", "peroxissoma", "mitocondria", "flagelo", "cloroplastos",
			"plasmodesmio", "nucleo", "cromossomo",  "centriolo" };
			
/* opcao 4 */
	private String numero[] = { "duzentos", "quatrocentos", "quinhentos", "trezentos", "cinquenta",
			"oitocentos" };

/* opcao 5 */
	private String clube[] = { "palmeiras", "flamengo", "corinthians", "paisandu", "atletico", "cruzeiro",
			"fluminense", "guarani", "parana" };
			
/* opcao 6 */
	private String variavel[] = { "chaveiro", "relogio", "granito", "tijolo", "nuvem", "avenida", "coracao",
			"internet", "zovirax", "informacao", "substantivo", "telefone", "investimento", "amor" };

	public String busca(int opcao){
	/* funcao que retorna uma palavra da opcao escolhida, palavra escolhida randomicamente */
		
		Random rand = new Random();
	
		switch(opcao){
			case 0: return animal[rand.nextInt(animal.length)];
			case 1: return objeto[rand.nextInt(objeto.length)];
			case 2: return carro[rand.nextInt(carro.length)];
			case 3: return celula[rand.nextInt(celula.length)];
			case 4: return numero[rand.nextInt(numero.length)];
			case 5: return clube[rand.nextInt(clube.length)];
			default : return variavel[rand.nextInt(variavel.length)];
		}
	}
}

class telaAscii{
	/* classe de controle entrada e saida no prompt de texto */
	
	private static InputStreamReader FonteDeDados;
        private static BufferedReader    Entrada;
	
	public void limpar(){
	/* "limpa" a tela */
		for(int i=0; i<25; i++)
			System.out.println("\n");
	}
	
	public void forca(int andamento){
	/* funcao que recebe quantos erros o usuario cometeu e imprime a forca correspondente */
		
		int max=6,i;	/* max sao os | centrais da forca */
		
		/* cabecalho default para todos */
		System.out.println("\n _________");
		System.out.println("|\t  |");
					
		if(andamento==0)
			/* nenhum erro */
			System.out.println("|\t  ()");
		
			else{ 
				
			/* 1 erro */
			System.out.println("|        ###");
			System.out.println("|       (o.0)");
			
			if(andamento==2){
			/* 2 erros */
				max=max-3;
				for(i=0; i<3; i++)
					System.out.println("|\t  |");
			}
			if(andamento==3 || andamento==4){
			/* 3 ou 4 erros */
				max=max-3;
				System.out.println("|\t  |");
				if(andamento==3)
					System.out.println("|\t /");
				else
					System.out.println("|\t /|\\");
				
				System.out.println("|\t  |");
			}
			if(andamento==5 || andamento==6){
			/* 5 ou 6 erros */
				System.out.println("|\t  |");
				System.out.println("|\t /|\\");
				System.out.println("|\t  |");
				if(andamento==5)
					System.out.println("|\t_/");
				else
					System.out.println("|\t_/ \\_");
				
				max=max-4;
			}
			if(andamento==7){
			/* morte */
				System.out.println("|\t  -");
				System.out.println("|\t| | |");
				System.out.println("|\t  |");
				System.out.println("|\t_/ \\_\n|");
				max=max-5;
			}
		}
		/* coluna esquerda da forca */
		for(i=0; i<max; i++)
			System.out.println("|");
		/* "chao" da forca */
		System.out.println("=======================");
	}
		
	public int iniciar() throws IOException{
		/* funcao que inicia o jogo, primeiramente ela limpa a tela, exibe o titulo e pergunta a opcao de palavra a ser jogada */
				
		FonteDeDados = new InputStreamReader (System.in);
		Entrada      = new BufferedReader    (FonteDeDados);
		
		for(;;){
		/* faa ate que o usuario digite um numero, se nao for nenhum das opcoes, mas um numero, ele retornara como sendo diversos */
		
		limpar();	
		System.out.println("\t    ###");
		System.out.println("\t      #   ####    ####    ####");
		System.out.println("\t      #  #    #  #    #  #    #");
		System.out.println("\t      #  #    #  #       #    #");
		System.out.println("\t#     #  #    #  #  ###  #    #");
		System.out.println("\t#     #  #    #  #    #  #    #");
		System.out.println("\t #####    ####    ####    ####");
		System.out.println("#######");
		System.out.println("#         ####   #####    ####     ##");
		System.out.println("#        #    #  #    #  #    #   #  #");
		System.out.println("#####    #    #  #    #  #       #    #");
		System.out.println("#        #    #  #####   #       ######");
		System.out.println("#        #    #  #   #   #    #  #    #");
		System.out.println("#         ####   #    #   ####   #    #");
		System.out.println("\n\tBem vindo ao Jogo da Forca, escrito por Cesar opensrc@gmx.net");
		System.out.println("\nEscolha um tema:\n"+
				"\t[0] animais, [1] informatica, [2] carros, [3] est. celulares\n"+
				"\t[4] numeros, [5] clubes de futebol, [6] diversos. [7] sair");
		System.out.print("\nTema numero : ");
		String c = Entrada.readLine();
		
		if(c.length()!=0)	/* evitar  erro de indexacao */
		if(Character.isDigit(c.charAt(0)))
			return Integer.parseInt(c);
		}
	}
	
	public void status(int acertos, int erros,int tamanho, int opcao,StringBuffer erradas){
		/* status atual do jogo, numero de acertos, erros, chances de erros, tamanho da palavra em jogo e qual tipo da palavra */
		
		System.out.print("\nAcertos : " + acertos);
		System.out.print("\nErros   : " + erros);
		System.out.print("\nChances : " + (7-erros));
		System.out.print("\nCaracteres digitados errados { " + erradas + " } " + erradas.length() + "/7\n\n\t" );
			
		switch(opcao){
			case 0: System.out.print("Animal");	break;
			case 1: System.out.print("Objeto de um computador");	break;
			case 2: System.out.print("Nome de um carro");	break;
			case 3: System.out.print("Componente de uma celula");	break;
			case 4: System.out.print("Numero");	break;
			case 5: System.out.print("Clube de futebol");	break;
			default : System.out.print("Palavra");	break;
		}
		System.out.print(" com " + tamanho +" letras");
	}
	
	public char enter(StringBuffer and) throws IOException {
		/* entrada do caracter por parte do usuario, le e retorna para quem chamou somente um caracter */
		
		FonteDeDados = new InputStreamReader (System.in);
		Entrada      = new BufferedReader    (FonteDeDados);
				
		System.out.println("Palavra: " + and + "\n");
		
		for(;;){
		System.out.print("\nDigite um caracter: ");
		String entra = Entrada.readLine(); /* le uma letra do jogador */
			
			if(entra.length()!=0){	/* evitar  erro de indexacao */
				char recebe = entra.charAt(0);	/* transforma pra char */
				recebe = Character.toLowerCase(recebe); /* transforma ele para minusculo */
				return recebe;
			}
		}
	}
	
	public void resultado(int result, String chave)throws IOException {
		/* imprime resultado final do jogo na tela, junto com o "gabarito" */
		
		FonteDeDados = new InputStreamReader (System.in);
		Entrada      = new BufferedReader    (FonteDeDados);
		
		if(result==1)
			System.out.println(": " + chave + "\n\t   Parabens voce VENCEU\n");
		else
			System.out.println(": " + chave + "\n\n\t  Voce PERDEU !\n");
		
		System.out.println("Cesar Henrique Kallas - opensrc@gmx.net - 06/2003");
		System.out.print("Pressione [enter] para continuar...");
		String pausa = Entrada.readLine();
	}
}
	
class jogo{
	/* classe de controle do jogo, nao le, nao exibe nada, apenas controla as jogadas junto com as classes telaAscii e palavra */
	
        private static telaAscii janela;
	private static Palavra	palavra;
	private static StringBuffer andamento,digitadasErradas;
	
	public static void main(String args[])throws IOException {
		
	for(;;){
	/* todo o jogo  orientado dentro desse for infinito, ate que o usuario digite 7 na tela de entrada para sair */
	
		int acertos=0, erros=0, aux=0, aux2=0, i;

		janela = new telaAscii();
		palavra = new Palavra();

		int numero = janela.iniciar();	/* retorna qual opcao o usuario escolheu de palavra */
				
		if(numero==7){	/* sair do jogo */
			janela.limpar();
			break;
		}
		
		String chave = palavra.busca(numero);	/* busca palavra com a opcao desejada */
		andamento = new StringBuffer();	/* copia do tamanho igual a chave */
		digitadasErradas = new StringBuffer(0);	/* string com letras digitadas erradas */
		
		for(aux=0; aux<chave.length(); aux++){	/* preenche com _ o vetor copia, com o tamanho da resposta */
			andamento.append("_");
			digitadasErradas.append("");
		}
		
		while(acertos<chave.length()){ /* sao duas condicoes de parada: errou 7 vezes ou acertou tantas vezes for o tamanho da palavra em jogo */
			
			janela.limpar();
			janela.status(acertos,erros,chave.length(),numero,digitadasErradas);	
			janela.forca(erros);
			char c = janela.enter(andamento);
			/* c = letra digitada pelo usuario */
			
			aux=0;
			for(i=0; i<chave.length(); i++){
				if(andamento.charAt(i)==c)/* se letra digitada ja tiver sido mencionada anteriormente (repeticao), nao conta erro nem acerto*/
					aux=50;
				else
				if(chave.charAt(i)==c)/* se a letra digitada estiver presente na palavra chave, a string sendo formada apaga o _ e inseri a letra */
				{
					andamento.deleteCharAt(i);
					andamento.insert(i,c);
					aux++;	/* variavel que auxilia no controle de erros e acertos */
					aux2++; /* variavel que controla o tanto de acertos que ocorreu, se tiver mais de uma letra na string, ele conta mais de um acerto */
				}
			}
			
			switch(aux){
				case 0 : {	/* nao encontrou nada */
						digitadasErradas.insert(digitadasErradas.length(),c);	/* preenche string com letras digitadas erradas, para melhor andamento do jogo */
						erros++;
						break;	
				}
				case 50: break;	/* encontrou a letra, mas ja havia sido mencionada antes */
				default: acertos=acertos+aux2;	break;	/* acertou */
			}
			aux=0;
			aux2=0;
						
			if(erros==7)break;	/* se ja errou o bastante */
		}
		
		janela.limpar();
		janela.forca(erros);	/* ganhou, nao foi enforcado, intao volta ao inicio = 0 */
		janela.status(acertos,erros,chave.length(),numero,digitadasErradas);
		
		if(acertos==chave.length())	/* se o numero de acertos for igual ao tamanho da palavra em jogo, ele ganhou */
			janela.resultado(1,chave);
		else /* o jogador errou 7 vezes, que eh o numero maximo */
			janela.resultado(0,chave);
		
	}
	System.exit(0);	/* termino do programa ok */
	}
}